/******************************************************************************
ư롼Ǥ

δؿ⡢ϰϤˤդɬפǤ
******************************************************************************/

#include <stdio.h>
#include <ctype.h>		/* isdigit */
#include "tx.h"

/*  main --- delete ƹޤ ---
main() {
	Myfloat mf1, mf2;
	char s1[128], s2[128], s3[128];

	while (1) {
		fflush(stdin);
		Myfloat_fscanf(&mf1, stdin);
		scanf("\n");
		Myfloat_fscanf(&mf2, stdin);

		Myfloat_sprintf(s1, mf1);
		Myfloat_sprintf(s2, mf2);
		Myfloat_sprintf(s3, Myfloat_div(mf1, mf2, 3));

		printf("%s / %s = %s\n", s1, s2 , s3);
	}
}
*/


/******************************************************************************
ڴؿ̾	Myfloat_sprintf
ڵǽ	Myfloat ֥ȤʸѴ롣
ڰ	ʸ򤪤륢ɥ쥹 t, Myfloat ֥ f.
͡	t.
ա	t ϽʬĹʤƤϤʤʤ
******************************************************************************/
char* Myfloat_sprintf(char* t, Myfloat f) {
	long power = 1;
	int n;

	for (n = 0; n < f.precision; n++) {
		power *= 10;
	}
	sprintf(t, "%lu.%0*lu", f.number / power, f.precision, f.number % power);

	return t;
} /* Myfloat_sprintf */


/******************************************************************************
ڴؿ̾	Myfloat_sscanf
ڵǽ	ʸ󤫤 Myfloat ֥Ȥɤ߹ࡣ
ڰ	ʸɤ߹ Myfloat ؤΥɥ쥹
͡	0.
******************************************************************************/
int Myfloat_sscanf(char* cp, Myfloat* fp) {
	fp->number = 0;
	fp->precision = 0;

	while (*cp != '\0' && isdigit(*cp)) {
		fp->number *= 10;
		fp->number += *cp - '0';
		cp++;
	}
	if (*cp == '\0') {
		return 0;
	}
	if (*cp != '.') {
		return 0;
	}
	cp++;
	while (*cp != '\0' && isdigit(*cp)) {
		fp->number *= 10;
		fp->number += *cp - '0';
		fp->precision++;
		cp++;
	}
	return 0;
} /* Myfloat_sscanf */


/******************************************************************************
ڴؿ̾	Myfloat_init
ڵǽ	Myfloat ֥Ȥͭǽ
ڰ	Myfloat ֥ȤؤΥɥ쥹ʬ졢ʬҡ١
͡	ʤ
******************************************************************************/
void Myfloat_init(Myfloat* fp, long num, long denom, int precision) {
	fp->precision = precision;

	while (precision--) {
		num *= 10;
	}
	fp->number = num / denom;
} /* Myfloat_init */


/******************************************************************************
ڴؿ̾	Myfloat_cmp
ڵǽ	Myfloat ֥Ȥ羮Ӥ롣
ڰ	Myfloat ֥ f, g.
͡	f > g, f = g, f < g ˱ơοο
******************************************************************************/
long Myfloat_cmp(Myfloat f, Myfloat g) {
	int i = f.precision - g.precision;

	if (i > 0) {
		while (i--) {
			g.number *= 10;
		}
	} else {
		while (i++) {
			f.number *= 10;
		}
	}
	return f.number - g.number;
} /* Myfloat_cmp */


/****************************************************************************
ڴؿ̾	Myfloat_div
ڵǽ	Ĥ Myfloat ֤
ڰ	Ĥ Myfloat ֥ȡ١
֤͡	档
ڥᡡ	(n1/10^a1)/(n2/10^a2) = (n1/n2)/(10^(a1-a2))
****************************************************************************/
Myfloat Myfloat_div(Myfloat mf1, Myfloat mf2, int prec) {
	Myfloat ret;
	int i = mf1.precision - mf2.precision - prec;

	if (i > 0) {
		while (i--) {
			mf2.number *= 10;
		}
	} else {
		while (i++) {
			mf1.number *= 10;
		}
	}
	ret.number = mf1.number / mf2.number;
	ret.precision = prec;
	return ret;
} /* Myfloat_div */
